// : http://forum.codenet.ru/q75175

//      TStringGrid
unit MainUnit;

interface

uses
  Windows, Classes, Controls, Forms, Grids, ComCtrls, Buttons, ExtCtrls,
  Dialogs, StdCtrls, Graphics, SysUtils;

type
  TMainForm = class(TForm)
    StringGrid: TStringGrid;
    TrackBar: TTrackBar;
    Panel: TPanel;
    SButEllipse: TSpeedButton;
    SButRect: TSpeedButton;
    ButtonBodyColor: TButton;
    ColorDialog: TColorDialog;
    ButtonPenColor: TButton;
    SButRhomb: TSpeedButton;
    procedure StringGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TrackBarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SButClick(Sender: TObject);
    procedure ButtonPenColorClick(Sender: TObject);
    procedure ButtonBodyColorClick(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses DrawableItems;

const
  TAG_ELLIPSE = 1000;
  TAG_RECT    = 2000;
  TAG_RHOMB   = 3000;

var
  //  ( ,    )
  CurrentTag: Integer;
  CurrentPenColor: TColor;
  CurrentBodyColor: TColor;

procedure TMainForm.ButtonBodyColorClick(Sender: TObject);
begin
  If ColorDialog.Execute then
  begin
    CurrentBodyColor:= ColorDialog.Color;
    StringGrid.Refresh;
  end;
end;

procedure TMainForm.ButtonPenColorClick(Sender: TObject);
begin
  If ColorDialog.Execute then
  begin
    CurrentPenColor:= ColorDialog.Color;
    StringGrid.Refresh;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
  J: Integer;
begin
  for I := 0 to StringGrid.ColCount - 1 do
    for J := 0 to StringGrid.RowCount - 1 do
      StringGrid.Objects[I,J].Free; 
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SButEllipse.Tag:= TAG_ELLIPSE;
  SButRect.Tag:= TAG_RECT;
  SButRhomb.Tag:= TAG_RHOMB;
end;

procedure TMainForm.SButClick(Sender: TObject);
begin
  CurrentTag:= (Sender as TSpeedButton).Tag;
end;

procedure TMainForm.StringGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if StringGrid.Objects[ACol, ARow] <> Nil then
    with (StringGrid.Objects[ACol, ARow] as TDrawableItem) do
    begin
      BodyColor:= CurrentBodyColor;
      PenColor:= CurrentPenColor;
      Draw(StringGrid.Canvas, Rect);//  
    end;
end;

procedure TMainForm.StringGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  If Button <> mbLeft then Exit;

  //       
  StringGrid.Objects[StringGrid.Col, StringGrid.Row].Free;
  StringGrid.Objects[StringGrid.Col, StringGrid.Row]:= Nil;

  case CurrentTag of
    TAG_ELLIPSE:  StringGrid.Objects[StringGrid.Col, StringGrid.Row]:=
                    TEllipseItem.Create;
    TAG_RECT:     StringGrid.Objects[StringGrid.Col, StringGrid.Row]:=
                    TRectangleItem.Create;
    TAG_RHOMB:    StringGrid.Objects[StringGrid.Col, StringGrid.Row]:=
                    TRhombusItem.Create;
  end;

end;

procedure TMainForm.TrackBarChange(Sender: TObject);
begin
  StringGrid.DefaultColWidth:= 64 + TrackBar.Position;
  StringGrid.DefaultRowHeight:= StringGrid.DefaultColWidth;
end;

end.
